#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2two8004xi.py">
#<abstract4xi abstract = "fires to direction two and to distance 800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2two8004xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2TWO - COORDINATE SIGNS OF SHOOT2TWO4XI: (X + ,Y - ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2two8004xi

#"
#/>

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

# -------------------------------------------------------------------------------------------------
# 800
# -------------------------------------------------------------------------------------------------
shot2two8004xi = {
        1:'104x-334y-829z',
        2:'108x-496y-618z',
        3:'10x-432y-672z',
        4:'111x-791y-40z',
        5:'112x-382y-693z',
        6:'129x-369y-697z',
        7:'132x-483y-623z',
        8:'146x-355y-701z',
        9:'14x-347y-720z',
        10:'152x-783y-48z',
        11:'155x-470y-628z',
        12:'161x-341y-705z',
        13:'175x-326y-709z',
        14:'177x-455y-632z',
        15:'188x-310y-712z',
        16:'193x-774y-56z',
        17:'198x-439y-637z',
        18:'200x-294y-716z',
        19:'211x-277y-719z',
        20:'218x-423y-642z',
        21:'221x-260y-723z',
        22:'222x-6y-768z',
        23:'229x-18y-766z',
        24:'229x-243y-726z',
        25:'233x-762y-64z',
        26:'235x-31y-763z',
        27:'236x-225y-730z',
        28:'237x-405y-647z',
        29:'240x-45y-761z',
        30:'242x-208y-733z',
        31:'245x-59y-759z',
        32:'247x-190y-736z',
        33:'249x-74y-756z',
        34:'251x-173y-739z',
        35:'252x-90y-753z',
        36:'253x-156y-742z',
        37:'254x-106y-751z',
        38:'254x-122y-748z',
        39:'254x-139y-745z',
        40:'254x-387y-652z',
        41:'270x-368y-656z',
        42:'272x-748y-72z',
        43:'285x-348y-661z',
        44:'28x-799y-24z',
        45:'298x-328y-665z',
        46:'30x-525y-602z',
        47:'310x-307y-670z',
        48:'311x-732y-80z',
        49:'31x-339y-723z',
        50:'321x-286y-674z',
        51:'32x-424y-677z',
        52:'330x-264y-678z',
        53:'338x-15y-724z',
        54:'338x-243y-682z',
        55:'344x-34y-721z',
        56:'345x-221y-686z',
        57:'348x-714y-88z',
        58:'349x-53y-717z',
        59:'350x-199y-691z',
        60:'353x-177y-695z',
        61:'353x-72y-713z',
        62:'356x-156y-698z',
        63:'356x-93y-710z',
        64:'357x-113y-706z',
        65:'357x-134y-702z',
        66:'375x-706y0z',
        67:'385x-694y-96z',
        68:'3x-532y-597z',
        69:'412x-685y-7z',
        70:'420x-672y-104z',
        71:'447x-663y-15z',
        72:'454x-648y-112z',
        73:'481x-638y-23z',
        74:'487x-622y-120z',
        75:'48x-329y-727z',
        76:'513x-612y-31z',
        77:'518x-595y-128z',
        78:'53x-415y-681z',
        79:'544x-584y-39z',
        80:'547x-566y-136z',
        81:'574x-554y-47z',
        82:'575x-536y-144z',
        83:'57x-517y-607z',
        84:'601x-504y-151z',
        85:'602x-523y-55z',
        86:'626x-471y-159z',
        87:'628x-490y-63z',
        88:'648x-437y-167z',
        89:'64x-319y-730z',
        90:'652x-457y-71z',
        91:'669x-401y-175z',
        92:'675x-421y-79z',
        93:'687x-365y-183z',
        94:'695x-385y-87z',
        95:'704x-327y-190z',
        96:'70x-796y-32z',
        97:'713x-348y-95z',
        98:'718x-289y-198z',
        99:'730x-251y-206z',
        100:'730x-309y-103z',
        101:'73x-405y-685z',
        102:'741x-212y-214z',
        103:'744x-270y-111z',
        104:'749x-172y-221z',
        105:'754x-132y-229z',
        106:'756x-231y-119z',
        107:'758x-92y-237z',
        108:'759x-12y-252z',
        109:'759x-52y-244z',
        110:'766x-191y-126z',
        111:'772x-207y-2z',
        112:'774x-150y-134z',
        113:'779x-109y-142z',
        114:'782x-166y-10z',
        115:'782x-68y-150z',
        116:'783x-27y-158z',
        117:'789x-125y-18z',
        118:'795x-83y-26z',
        119:'798x-41y-34z',
        120:'79x-308y-733z',
        121:'83x-507y-612z',
        122:'93x-394y-689z'}
        
        
#"
#"/>

        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire800two4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire800two4xi(queue2two, consumer_channel2two, publisher_channel2two):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE800TWO4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE800TWO4XI -  QUEUE2TWO: ", queue2two)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE800TWO4XI -  CONSUMER_CHANNEL2TWO: ", consumer_channel2two)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE800TWO4XI -  PUBLISHER_CHANNEL2TWO: ", publisher_channel2two)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE800TWO4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2two.put(shot2two8004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE800TWO4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE800TWO4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2TWO: ", queue2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE800TWO4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2two8shot2two8004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2two8shot2two8004xi</nack2put4xi>" 
            
        publisher_channel2two.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE800TWO4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE800TWO4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2TWO: ", publisher_channel2two, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE800TWO4XI - RETURNING QUEUE OBJECT QUEUE2TWO: ", queue2two, " - TIME: ", time4xi())  
        # 
            
    return queue2two    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verbkb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2two8004xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
        